" version 0.62:
	" Added support for ZPT.
	" Added (guessed)meta_type in statusline.

" version 0.61:
	" Added an indicator in the statusline when sending.

" version 0.60b:
	" Initial public release.

" to do:
	" A lot of things
	" Guessing of meta_type is rough and is based on content :( 
	" the funct ZopeMETA should be improved to allow setting metatype before
	" uploading, if meta_type has been wrong guessed.

	" Why not using pyf instead py? The mix of VIM_code and python is not
	" wonderful, it's funny ;) .

" requirements:
	" Python support compiled in VIM
	" Expression evaluation support compiled in VIM


command! ZopeCOMMANDS :call ZopeCOMMANDS()

py import vim, time
py import os, re, httplib, urllib, os, string, base64, urlparse

se laststatus=2
se sessionoptions+=globals

let g:User=""     "can be stored in a session, :mksession <sessfile>
let g:password=""
let g:cookies=""
let g:Url=""      "can be stored in a session, :mksession <sessfile>
let g:lastsent="???"
let g:metatype="???"


function! ZopeCOMMANDS()
	set statusline=%<%f%h%m\ %{g:Url}\ *%{g:lastsent}\ %{g:metatype}%r%=%l,%c%V\ %P
	let res=0
	echohl WildMenu | echo "\nUser:".g:User."  URL:http://".g:Url | echohl None
	while res!=1
		let res=confirm("What to do? ", "&cancel\n&user\n&passwd\nu&rl\n&get\n&send\nc&ookies\n&meta", 1) 
		if res==1
			return
		elseif res==2
			echo "Current:" g:User
			let tmp=input("User? ")
			if tmp!=""
	  			let g:User=tmp
    		endif
		elseif res==3
			if v:version<600
			  let g:password=input("Password (alert! people can see)?")
			else
			  let g:password=inputsecret("Password? ")
			endif
		elseif res==4
			echo "Current:" g:Url
			let tmp=input("URL? ")
			if tmp!=""
	  			let g:Url=tmp
    		endif
			let g:Url=substitute(g:Url, "^http://", "", "")
		elseif res==5
			call ZopeGET()
		elseif res==6
			call ZopeSEND()
		elseif res==7
			call ZopeCOOKIES()
		elseif res==8
			call ZopeMETA()
		endif
		echohl WildMenu | echo "\nUser:".g:User."  URL:http://".g:Url | echohl None
	endwhile
endfunction


function! ZopeMETA()
	" try to guess META-TYPE, need improving
	py data=string.join(vim.current.buffer,'\n')
	py if string.find(data, " tal:")!=-1: metatype='ZPT'
	py if string.find(data, "## Script (Python)")!=-1: metatype='PYT'
	py if string.find(data, "## Script (Python)")==-1 and string.find(data, " tal:")==-1: metatype='DTML'
	py vim.command('let g:metatype="%s"' % metatype)
	set statusline=%<%f%h%m\ %{g:Url}\ *%{g:lastsent}\ %{g:metatype}%r%=%l,%c%V\ %P
	echohl StatusLine | echo "I think this is ".g:metatype | echohl None
endf

function! ZopeCOOKIES()
	"set your cookies plain text file
	py cookieFile=open(os.environ['HOME']+'/.galeon/mozilla/galeon/cookies.txt')
	py cookies=cookieFile.readlines()
	py vim.command('let flag=%d' % len(cookies))
	while flag>0
		py cookies[0]=string.replace(cookies[0],'"','\\x22')
		py vim.command('let line="%s"' % cookies[0])
		py line=cookies[0]
		py del cookies[0]
		py vim.command('let flag=%d' % len(cookies))
        "what cookies? set your matching string prefs
		if line !~ ".bizy" && line !~ ".open4"
			continue
		elseif line !~ "__ac"
			continue
		endif
		py line=re.split('\s+', line)
		py line=string.join((line[0], line[5]+'='+line[6]+';'))
		py line=string.replace(line,'"','\\x22"')
		py vim.command('let line="%s"' % line)
		echohl StatusLine | echo line | echohl None
	endwhile
	py cookieFile.close()
	echo "Current: " g:cookies
	let tmp=input("Cookies? ")
	if tmp!=""
	  let g:cookies=tmp
    endif
endf


function! ZopeSEND()
	let res=confirm("Save to http://".g:User.":"."xxx@".g:Url." ?", "&yes\n&no\n&commands", 2) 
	if res==1
		py data=string.join(vim.current.buffer,'\n')
		py auth=base64.encodestring(vim.eval('g:User')+':'+vim.eval('g:password'))
		py params=urllib.urlencode({'file':data})
		py h=httplib.HTTP(string.split(vim.eval('g:Url'),'/')[0])

		" try to guess META-TYPE. Arghh! code's repetition
		py if string.find(data, " tal:")!=-1: h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1]+'/pt_upload'); metatype='ZPT'
		py if string.find(data, "## Script (Python)")!=-1: h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1]+'/ZPythonScriptHTML_upload'); metatype='PYT'
		py if string.find(data, "## Script (Python)")==-1 and string.find(data, " tal:")==-1: h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1]+'/manage_upload'); metatype='DTML'
		py vim.command('let g:metatype="%s"' % metatype)
		set statusline=%<%f%h%m\ %{g:Url}\ *%{g:lastsent}\ %{g:metatype}%r%=%l,%c%V\ %P

		py h.putheader('Content-type', 'application/x-www-form-urlencoded')
		py h.putheader('Content-length', '%d' % len(params))
		py h.putheader('Accept', 'text/plain')
		py h.putheader('Host', string.split(vim.eval('g:Url'),'/')[0])
		py h.putheader('Authorization', 'Basic '+auth[:-1])
		py h.putheader('Cookie', vim.eval('g:cookies'))
		py h.endheaders()
		py h.send(params)
		py (reply, msg, hdrs)=h.getreply()
		py print reply
		py print msg
		py print hdrs
		
		py vim.command('let err=%d' % reply)
		if err!=200
			echohl ErrorMsg | echo "Error!" | echohl None
		else
			py vim.command('let g:lastsent="%s"' % time.strftime("%y%m%d %H:%M:%S", time.localtime(time.time())))
			set statusline=%<%f%h%m\ %{g:Url}\ *%{g:lastsent}\ %{g:metatype}%r%=%l,%c%V\ %P
			echohl Title | echo "Sent!" | echohl None
		endif
	elseif res==2
		echohl ErrorMsg | echo "Aborted!" | echohl None
	elseif res==3
		call ZopeCOMMANDS()
	endif
endf


function! ZopeGET()
	let res=confirm("Get http://".g:User.":xxx@".g:Url."/document_src ?", "&yes\n&wo doc src\n&no\n&commands", 3)
	if res==1 || res==2
		py auth=base64.encodestring(vim.eval('g:User')+':'+vim.eval('g:password'))
		py h=httplib.HTTP(string.split(vim.eval('g:Url'),'/')[0])
		if res==1
			py h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1]+'/document_src')
		else
			py h.putrequest('POST', '/'+string.split(vim.eval('g:Url'),'/',1)[1])
		endif
		py h.putheader('Content-type', 'application/x-www-form-urlencoded')
		py h.putheader('Content-length', '%d' % 0)
		py h.putheader('Accept', 'text/plain')
		py h.putheader('Host', string.split(vim.eval('g:Url'),'/')[0])
		py h.putheader('Authorization', 'Basic '+auth[:-1])
		py h.putheader('Cookie', vim.eval('g:cookies'))
		py h.endheaders()
		py h.send('')
		py (reply, msg, hdrs)=h.getreply()
		py print reply
		py print msg
		py print hdrs

		py vim.command('let err=%d' % reply)
		if err!=200
			echohl ErrorMsg | echo "Error!" | echohl None
		else
			py lines=h.getfile().readlines()
			py data=string.join(lines, '\n')

			" try to guess META-TYPE. Arghh! code's repetition
			py if string.find(data, " tal:")!=-1: metatype='ZPT'
			py if string.find(data, "## Script (Python)")!=-1: metatype='PYT'
			py if string.find(data, "## Script (Python)")==-1 and string.find(data, " tal:")==-1: metatype='DTML'
			py vim.command('let g:metatype="%s"' % metatype)

			py if len(lines)>0 and lines[-1][-1]!='\n': lines[-1]=lines[-1]+'\n'
			py vim.current.buffer.append(map(lambda x: x[:-1], lines))
			set statusline=%<%f%h%m\ %{g:Url}\ *%{g:lastsent}\ %{g:metatype}%r%=%l,%c%V\ %P
			echohl Title | echo "Received!" | echohl None
		endif
	elseif res==3
		echohl ErrorMsg | echo "Aborted!" | echohl None
	elseif res==4
		call ZopeCOMMANDS()
	endif
endf


" vim:ts=4:sw=4
